
QGIS Application - Bug report #8241

Make ftools work also when inputs have columns wider than 10 characters

2013-07-08 07:39 PM - Aren Cambre

Status: Closed

Priority: Normal

Assignee:

Category: Processing/QGIS

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 17052

Description

New description:

a few tools in the vector menu are unable to cope with attributes with names of > 10 chars. The tools are

doGeoprocessing.py

intersect

    union

    symetrical_difference

doSpatialJoin.py

spatialjoin

Please see #8241-3 for a detailed description

Old description:

I have a PostGIS table with a field name that has more than 10 characters in the name. The Symmetrical difference feature fails with a

message that simply advises of this problem but gives no solutions.

I really, really need to keep descriptive field names in the original data, so renaming fields is very undesirable.

I can think of a few workarounds, but seems like it would be easy to just use a truncated field name, with a check to ensure the truncated

field name dos not duplicate any other field names.

Associated revisions

Revision 8ae64b43 - 2013-07-10 03:01 PM - Minoru Akagi

fTools: remove unnecessary checks on output field names (fix #8241)

History

#1 - 2013-07-08 07:39 PM - Aren Cambre

Related: #3857

#2 - 2013-07-09 01:41 AM - Giovanni Manghi
- Tracker changed from Bug report to Feature request

- Subject changed from Symmetrical difference fails if field name is more than 10 characters to Make "symmetrical difference" work also when inputs 

have columns wider than 10 characters

- Operating System deleted (Windows 7 x64)

- Category changed from Vectors to 44

- Target version changed from Version 2.0.0 to Future Release - Nice to have

The error message could be a little more verbose, but it is right anyway: the output of the geoprocessing tools are shapefiles, regardless of the input data

type, and shapefiles are limited to 10 chars for columns names.

Sure there can be workarounds (like truncating the columns names, like the "join" does) or real solutions (like make the geoprocessing tools create an

output in the same data type as the inputs, or of a kind at user choice), but are all feature requests.

#3 - 2013-07-09 03:57 AM - Minoru Akagi

Some fTools' processes are sometimes discontinued for the same reason. Especially with "Join attributes by location" tool, when we select the MEAN

option, the length of the field names must be only six or less. Processes are often stopped unnecessarily and users are forced to change the field names,

so I think this is a bug. Since no error occurs even when long field names are passed to QgsVectorFileWriter and the writer truncates the field names to the

appropriate length, the fix should be very easy. Showing message like "Following field names will be truncated to 10 bytes" would be helpful for users, but

we are currently in string freeze, and it is not necessary.

#4 - 2013-07-09 04:06 AM - Giovanni Manghi

Minoru Akagi wrote:

Some fTools' processes are sometimes discontinued for the same reason. Especially with "Join attributes by location" tool, when we select the

MEAN option, the length of the field names must be only six or less. Processes are often stopped "unnecessarily" and users are forced to change

the field names, so I think this is a bug. Since no error occurs even when long field names are passed to QgsVectorFileWriter and the writer

truncates the field names to the appropriate length, the fix should be very easy. Showing message like "Following field names will be truncated to 10

bytes" would be helpful for users, but we are currently in string freeze, and it is not necessary.

If this issue is widespread in the vector menu tools then I agree that this should be a bug. Then title and description of this ticket must be rephrased

(eventually listing all the tools that do not work because of this issue), please go ahead.

#5 - 2013-07-09 04:54 AM - Minoru Akagi

I cannot retitle this ticket, so I list 4 tools using ftools_utils.checkFieldNameLength() instead.

doGeoprocessing.py

    -  intersect

    -  union

    -  symetrical_difference

doSpatialJoin.py

    -  spatialjoin

#6 - 2013-07-09 07:36 AM - Giovanni Manghi

- Tracker changed from Feature request to Bug report

- Subject changed from Make "symmetrical difference" work also when inputs have columns wider than 10 characters to Make ftools work also when 
inputs have columns wider than 10 characters

#7 - 2013-07-13 09:10 PM - Minoru Akagi

- Status changed from Open to Closed

Fixed in changeset commit:"8ae64b438ecad7f927496af2c4d833339781b854".

#8 - 2017-05-01 01:21 AM - Giovanni Manghi

The "ftools" category is being removed from the tracker, changing the category of this ticket to "Processing/QGIS" to not leave the category orphaned.

#9 - 2017-05-19 09:34 AM - Jürgen Fischer

- Regression? set to No

- Description updated

- Easy fix? set to No
